=== modified file 'bzrlib/export/__init__.py'
--- bzrlib/export/__init__.py	2011-03-13 19:10:45 +0000
+++ bzrlib/export/__init__.py	2011-03-13 19:43:03 +0000
@@ -151,11 +151,12 @@
     return dest
 
 
-def _export_iter_entries(tree, subdir):
+def _export_iter_entries(tree, subdir, skip_special=True):
     """Iter the entries for tree suitable for exporting.
 
     :param tree: A tree object.
     :param subdir: None or the path of an entry to start exporting from.
+    :param skip_special: Whether to skip .bzr files.
     """
     inv = tree.inventory
     if subdir is None:
@@ -177,7 +178,7 @@
     for entry in entries:
         # The .bzr* namespace is reserved for "magic" files like
         # .bzrignore and .bzrrules - do not export these
-        if entry[0].startswith(".bzr"):
+        if skip_special and entry[0].startswith(".bzr"):
             continue
         if subdir is None:
             if not tree.has_filename(entry[0]):

=== modified file 'bzrlib/export/tar_exporter.py'
--- bzrlib/export/tar_exporter.py	2011-03-13 19:11:46 +0000
+++ bzrlib/export/tar_exporter.py	2011-03-13 19:43:03 +0000
@@ -23,7 +23,6 @@
 
 from bzrlib import (
     errors,
-    export,
     osutils,
     )
 from bzrlib.export import _export_iter_entries
@@ -104,8 +103,6 @@
         stream = gzip.GzipFile(None, mode='w', mtime=root_mtime,
             fileobj=sys.stdout)
     else:
-        if root is None:
-            root = export.get_root_name(dest)
         stream = gzip.GzipFile(dest.encode(osutils._fs_enc), 'w',
             mtime=root_mtime)
     ball = tarfile.open(None, 'w:', fileobj=stream)
@@ -125,9 +122,6 @@
         # named '-/foo'; perhaps this is the most reasonable thing.
         ball = tarfile.open(None, 'w|bz2', sys.stdout)
     else:
-        if root is None:
-            root = export.get_root_name(dest)
-
         # tarfile.open goes on to do 'os.getcwd() + dest' for opening
         # the tar file. With dest being unicode, this throws UnicodeDecodeError
         # unless we encode dest before passing it on. This works around
@@ -151,9 +145,6 @@
         # named '-/foo'; perhaps this is the most reasonable thing.
         ball = tarfile.open(None, 'w|', sys.stdout)
     else:
-        if root is None:
-            root = export.get_root_name(dest)
-
         # tarfile.open goes on to do 'os.getcwd() + dest' for opening
         # the tar file. With dest being unicode, this throws UnicodeDecodeError
         # unless we encode dest before passing it on. This works around

